/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package panel;

import java.awt.Font;
import java.sql.*;
import Connection.ConnectionDB;
import PlugIn.SubDefaultTableModel;
import database.GuestDB;
import database.StoreDB;
import java.awt.Color;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JOptionPane;
import resources.Component;
import resources.Guest;
/**
 *
 * @author chinda
 */
public class InforReturnMoney extends javax.swing.JPanel {

    /**
     * Creates new form InforReturnMoney
     */
    public InforReturnMoney() {
        initComponents();
        com = new Component();
        mod = new SubDefaultTableModel(null,new Object[]{com.getRb().getString("lbNo"),com.getRb().getString("lbGuestId"),com.getRb().getString("lbName"),
            com.getRb().getString("lbGender"),com.getRb().getString("lbVillage"),com.getRb().getString("lbRiel"),com.getRb().getString("lbDollar"),com.getRb().getString("lbDong"),
            com.getRb().getString("lbDate"),com.getRb().getString("lbOther")});
        com.setLable(new String[]{"lbVillage","lbSearchName","lbInforReturnMoneyTitle"}, lbVillage,lbSearchName,lbInforReturnMoneyTitle);
        tbl.setModel(mod);
        lsGuest = new GuestDB();
        lsVillage = new ArrayList<>();
        getVillage();
        
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lbInforReturnMoneyTitle = new javax.swing.JLabel();
        lbVillage = new javax.swing.JLabel();
        cbmVillage = new javax.swing.JComboBox<>();
        lbSearchName = new javax.swing.JLabel();
        txtSearchName = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        jScrollPane1 = new javax.swing.JScrollPane();
        tbl = new PlugIn.SubJTable();

        setBackground(java.awt.Color.white);
        addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                formMouseClicked(evt);
            }
        });

        lbInforReturnMoneyTitle.setFont(new java.awt.Font("Khmer OS Battambang", 1, 24)); // NOI18N
        lbInforReturnMoneyTitle.setForeground(new java.awt.Color(204, 0, 0));
        lbInforReturnMoneyTitle.setText("ពត៌មានសម្រាប់សងចំណងដៃ");

        lbVillage.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        lbVillage.setText("ឈ្មោះភូមិ");

        cbmVillage.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        cbmVillage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbmVillageActionPerformed(evt);
            }
        });

        lbSearchName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        lbSearchName.setText("ស្វែងរកឈ្មោះ");

        txtSearchName.setFont(new java.awt.Font("Khmer OS Battambang", 1, 14)); // NOI18N
        txtSearchName.addCaretListener(new javax.swing.event.CaretListener() {
            public void caretUpdate(javax.swing.event.CaretEvent evt) {
                txtSearchNameCaretUpdate(evt);
            }
        });

        tbl.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tbl.setColorSelected(new java.awt.Color(51, 204, 255));
        tbl.setFont(new java.awt.Font("Khmer OS Battambang", 0, 12)); // NOI18N
        tbl.setRowHeight(30);
        tbl.getTableHeader().setResizingAllowed(false);
        tbl.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(tbl);
        tbl.setFontHeader(new Font("Khmer OS Battambang",Font.BOLD,15));
        tbl.setColorSelected(new Color(23, 167, 239));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 336, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lbInforReturnMoneyTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 334, javax.swing.GroupLayout.PREFERRED_SIZE)))
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(lbVillage, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(12, 12, 12)
                .addComponent(cbmVillage, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(lbSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, 93, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(12, 12, 12)
                .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, 203, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(16, 16, 16)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 479, Short.MAX_VALUE)
                .addGap(18, 18, 18))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(39, 39, 39)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lbInforReturnMoneyTitle, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbVillage))
                    .addComponent(cbmVillage, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(3, 3, 3)
                        .addComponent(lbSearchName))
                    .addComponent(txtSearchName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 168, Short.MAX_VALUE)
                .addGap(6, 6, 6))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cbmVillageActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbmVillageActionPerformed
        String village = cbmVillage.getSelectedItem()+"";
        String sql;
        if(village.isBlank()){
            sql = "select * from viewreturnmoney";
        }else
            sql = "select * from viewreturnmoney where village = '"+village.trim()+"'";
        getDatabase(sql);
    }//GEN-LAST:event_cbmVillageActionPerformed

    private void txtSearchNameCaretUpdate(javax.swing.event.CaretEvent evt) {//GEN-FIRST:event_txtSearchNameCaretUpdate
       List<Guest> list = lsGuest.getFilterName(txtSearchName.getText().trim());
        DecimalFormat df = new DecimalFormat("#,##0.00");
        mod.removeAllRows();
        for(int i=0; i<list.size(); i++)
            mod.addRow(new Object[]{i+1,list.get(i).getId(),list.get(i).getName(),list.get(i).getGender(),list.get(i).getVillage(),df.format(list.get(i).getReil())
                ,df.format(list.get(i).getDollar()),df.format(list.get(i).getDong()),list.get(i).getDate(),list.get(i).getOther()});

    }//GEN-LAST:event_txtSearchNameCaretUpdate

    private void formMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseClicked
        tbl.clearSelection();
    }//GEN-LAST:event_formMouseClicked
    private void getDatabase(String sql){
        try {
            Statement s  = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet rs = s.executeQuery(sql);
            DecimalFormat df = new DecimalFormat("#,##0.00");
            lsGuest.removeAll();
            mod.removeAllRows();
            int count =1;
            while(rs.next()){
                lsGuest.add(new Guest(rs.getInt(1), rs.getString(2), rs.getString(3), rs.getString(4), rs.getDouble(5), rs.getDouble(6),
                        rs.getDouble(7), rs.getString(8), rs.getString(9)));
                mod.addRow(new Object[]{count,rs.getInt(1), rs.getString(2), rs.getString(3), rs.getString(4), df.format(rs.getDouble(5)), 
                            df.format(rs.getDouble(6)),df.format(rs.getDouble(7)), rs.getString(8), rs.getString(9)});
                count++;
            }
            rs.close();
            s.close();
        } catch (Exception e) {
        }
    }
    private void getVillage(){
        try {
            String sql = "select distinct village from viewreturnmoney; ";
            Statement s = ConnectionDB.getDataCon().createStatement(1004, 1008);
            ResultSet rs = s.executeQuery(sql);
            cbmVillage.addItem("");
            while(rs.next())
                cbmVillage.addItem(rs.getString(1));
            rs.close();
            s.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage());
        }
    }
    private Component com;
    private SubDefaultTableModel mod;
    private StoreDB<Guest> lsGuest;
    private List<String> lsVillage;
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> cbmVillage;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel lbInforReturnMoneyTitle;
    private javax.swing.JLabel lbSearchName;
    private javax.swing.JLabel lbVillage;
    private PlugIn.SubJTable tbl;
    private javax.swing.JTextField txtSearchName;
    // End of variables declaration//GEN-END:variables
}
